#include "safe.h"
#define EXIT_SUCCESS 0
#define EXIT_FAILURE -1
#define SEEK_SET 0
#define SEEK_END 2
#define Tab 0x9
#define Space 0x20
#define Comma 0x2c
#define ZeroChar 0x30
#define NineChar 0x39
#define Equal 0x3d
#define A 0x41
#define F 0x46
#define Cl 0x63
#define El 0x65
#define Fl 0x66
#define Il 0x69
#define Ml 0x6d
#define Rl 0x72
//override include_sec 1
#include "../include/xlog.h"
#include "oadbgdatas.h"
#define mark_nothing -1
#define no_index -1
#define sprites_realloc_onepart 10*sizeof(long)
//to be at least 2, for presprites_init; and 1 for sprite_done (root 0 move to final)
struct preoadata{
	unsigned long* presprites;
	unsigned int size;
};
struct presprite{//presprites_size is intern
	unsigned long* apreframe;
	unsigned long* preframes;
	unsigned int size;//same as parent, at button is extra, here are ui16 frames, copy sprites mechanism that is padded for debugger
};
struct preframe{
	unsigned long* ustrings;
	unsigned int ussize;//Count=ui16 * :
	//attention that in a constantpool of actionrecordheader of ui16 there are, at maximum, 3 bytes constants(null and two bytes) counting in total 0xffff/3
	//null and one byte are 255 maximum
	unsigned long restore_ustrings;
	unsigned long* strings;
	unsigned int ssize;//Count=ui16 * :
	unsigned long restore_dstrings;
	unsigned int size;//DoAction has ui32 but overall also is a ui32
	unsigned long abranch;
	unsigned long branchpointer;//starting from abranch and descending
	unsigned long action_last;
	unsigned long* actions_if;//is also between action calls, if jump forwards to End must set if_flag
	unsigned int actions_if_size;
	unsigned long* actions_jump;//here is ok to have NULL next if to End
	unsigned int actions_jump_size;
	//log only
	long log_recalculation;//can be on 32 bits, multiple actions with a big pool, or multiple actions constant16 to constant8 reductions. good at log
	//
	unsigned long log_mem;
	unsigned long log_size;
	unsigned long log_allsize;//this is increasing so much at last indents
	unsigned int log_indents;//same as functions
	//
	unsigned long log_xsize;//example: a[a[a]]=a[a[a]] is 40 size vs 192 xsize
	unsigned int log_branchid;//for strings log
	unsigned int log_sizedfunctions;//why to make something spacial for oadata when here is fast
};
struct branch{
	unsigned long cuts;
	unsigned long size;// there are examples which tends to x4 from DoAction to .x. a branchcut has 12(16 if aligned), there are no 3 size(tag+end) DoAction from actionswf lib
	unsigned long* innerbranches;//for define functions and for 3rd part
	unsigned int isize;//same as oadata functions plus for 3rd that is bigger, a jump,push,define at least
	unsigned long topbranch;
	unsigned long suprabranch;
	unsigned long subbranch;
	unsigned int offset;//at jumpforward, and at log
	unsigned int offset_loop;//if the branch has a loop start, else use no_loop . and at forin_breaks
	unsigned int offset_break;//only 1 is logical, at second must error else will do segmentation
	unsigned long action_top;//branch start action, for mark, after compare
	unsigned long action_if;//is last suprabranch action (if is not root) to resolve jumpforward (ActionIf) if will be the case
	unsigned long action_loop;//if is an offset_loop, next will be the action_loop that can be linked (there are exceptions like ret_cont_break cases)
	unsigned long action_break;
	unsigned long action_cut;//to resolve cuts, can be the same with action_loop when whiletrue and then the cuts
	unsigned int log_id;//for strings log
	unsigned short log_fn;//nostalgia
	unsigned short log_backjumps;//not dataxu? totalvalues is short
	unsigned short log_fwdjumps;//not dataxu? totalvalues is short
};
struct branchcut{
	unsigned int* x;//ints everywhere and pointers for strings, will not memcpy
	unsigned int size;//same x size doctrine
};
struct ustring{
	unsigned long base;
	unsigned long off;
	unsigned long ubranch;
};
struct string{
	unsigned long base;
	unsigned long off;
	unsigned long* branches;
	unsigned int size;//same as number of branches
};
#define from_action 0
#define from_show 1
#define pad_default 0x100
#define no_loop 0xffFFffFF
#define output_nl xlog_nl//this must be the same with what is in memnl(), or change it
