long*global_presprites_size();
long*inter_extension(long*);
long*compare(unsigned char*,unsigned long,unsigned long);
void sprite_free(long*,long*);
long*preoadata_init(long*,long*);
void preoadata_free(long*,long*,unsigned char,unsigned long);
long*presprite_init(unsigned long*,long*,long*,unsigned char,unsigned char,unsigned long);
long*presprite_done(long*,unsigned short,unsigned short,long*,long*);
#include "common.h"
//multithread unsafe
unsigned int presprites_size;//same as sprites_size
//
long*fopen(long,long);
//
long*restore(long);
//
//
//
long*nframe_init(long,long);
//
long*     global_presprites_size(){
	return presprites_size;
};
unsigned char inter_extension_data[]=".data";unsigned char* p_inter_extension_data=inter_extension_data;
long*     inter_extension(long* psize){//1
	psize[0]=(long)sizeof(inter_extension_data);
	return p_inter_extension_data;
};
long*     compare(unsigned char* swf_fullpath,unsigned long presprites,unsigned long data){
	int* size;size=(long)strlen(swf_fullpath);
	int* size1=sizeof(inter_extension_data);
	size1=(long)size1+(long)size;
	int* prev;prev=(long)malloc(size1);
	if(prev!=NULL){
		memcpy(prev,swf_fullpath,size);
		size1=(long)size1-(long)size;
		size=(long)size+(long)prev;
		memcpy(size,p_inter_extension_data,size1);
		int* file;
		file=(long)fopen(prev,"rb");
		free(prev);
		unsigned char ok;
		if(file!=NULL){//will mark diffs
			unsigned long oldpreoadata;oldpreoadata=(long)restore(file);
			fclose(file);
			if(oldpreoadata!=NULL){
				ok=(long)mark_compare(oldpreoadata,presprites,presprites_size,data);
				restore_free(oldpreoadata);
				return ok;
			};
			return EXIT_FAILURE;
		};
		ok=(long)mark_all(presprites,presprites_size,data);
		return ok;
	};
	return EXIT_FAILURE;
};
void      sprite_free(long* s,long* start){//log is start != null
	long* sp;sp=(long)s[0];
	if(sp!=NULL){
		int frame_index;
		if(start!=NULL){
			s=(long)s-(long)start;
			s=(unsigned long)s/(long)sizeof(long);
			print_indent();
			print("id=%hu",s);
			print_indent();
			frame_index=(long)1;
		}else{
			frame_index=(long)no_index;
		};
		if(((struct sprite*)sp)->aframe!=NULL){
			frame_free(((struct sprite*)sp)->aframe,xlog_ainit_true,frame_index);
		};
		if(((struct sprite*)sp)->frames!=NULL){
			long* pointer;int* end;
			pointer=(long)((struct sprite*)sp)->frames;
			end=(long)((struct sprite*)sp)->size;
			end=(long)end+(long)pointer;
			while(pointer!=end){
				if(pointer[0]!=NULL){
					frame_free(pointer[0],xlog_ainit_false,frame_index);
				};
				pointer++;
				if(frame_index!=no_index){
					frame_index++;
				};
			};
			free(((struct sprite*)sp)->frames);
		};
		free(sp);
		if(frame_index!=no_index){
			print_unindent();
			print_unindent();
		};
	};
};
long*     preoadata_init(long* ppresprites,long* psprites){
	ppresprites[0]=(long)malloc(sprites_realloc_onepart);
	if(ppresprites[0]!=NULL){
		psprites[0]=(long)malloc(sprites_realloc_onepart);
		if(psprites[0]!=NULL){
			presprites_size=(long)0;
			return EXIT_SUCCESS;
		};
	};
	return EXIT_FAILURE;
};
void      preoadata_free(long* presprites,long* sprites,unsigned char log,unsigned long xstart){
	if(presprites!=NULL){
		if(sprites!=NULL){
			unsigned short preid;
			if(log==TRUE){
				preid=(long)0;//0root 1-FFFF sprite/button
				puts("presprites:");
			};
			long* ps;ps=(long)presprites;
			unsigned long pend;pend=(long)presprites;
			pend=(long)pend+(long)presprites_size;
			long* s;s=(long)sprites;
			while(ps!=pend){
				long* pres;pres=(long)ps[0];
				if(pres!=NULL){
					int frame_index;unsigned int frames;
					if(log==TRUE){
						print_indent();
						print("%hu",preid);
						print_indent();
						frame_index=(long)1;
						frames=(long)((struct presprite*)pres)->size;
						frames=(unsigned long)frames/(long)sizeof(long);
					}else{
						frame_index=(long)no_index;
					};
					if(((struct presprite*)pres)->apreframe!=NULL){
						preframe_free(((struct presprite*)pres)->apreframe,xlog_ainit_true,frame_index,xstart);
					};
					if(((struct presprite*)pres)->preframes!=NULL){//not making a template free because preframe is different than frame
						if(log==TRUE){
							frames--;
							print("frames=%hu",frames);
						};
						long* pointer;pointer=(long)((struct presprite*)pres)->preframes;
						unsigned long end;end=(long)((struct presprite*)pres)->size;
						end=(long)end+(long)pointer;
						while(pointer!=end){
							if(pointer[0]!=NULL){
								preframe_free(pointer[0],xlog_ainit_false,frame_index,xstart);
							};
							pointer++;
							if(log==TRUE){
								frame_index++;
							};
						};
						free(((struct presprite*)pres)->preframes);
						sprite_free(s,NULL);//and unfinished sprites, here is after an error
					};
					free(pres);
					if(log==TRUE){
						print_unindent();print_unindent();
					};
				};
				if(log==TRUE){
					preid++;
				};
				ps++;
				s++;
			};
			free(sprites);
			free(presprites);
		};
	};
};
//                       wordxu preid                                         at action only from here
long*     presprite_init(unsigned long* newpointer,long* ppresprites,long* psprites,unsigned char type,unsigned char ainit,unsigned long linestotal){
	newpointer=(long)newpointer*(long)sizeof(long);
	unsigned int newsize;newsize=(long)newpointer;
	newsize=(long)newsize+(long)sizeof(long);
	unsigned char ok;
	if((unsigned long)presprites_size<(unsigned long)newsize){//#else example: preid 0 after a sprite preid 2
		ok=(long)re_calloc(ppresprites,presprites_size,newsize);
		if(ok!=EXIT_SUCCESS){
			return EXIT_FAILURE;
		};
		ok=(long)re_calloc(psprites,presprites_size,newsize);//and for sprites, but before sprite_done, with a preid
		if(ok!=EXIT_SUCCESS){
			return EXIT_FAILURE;
		};
		presprites_size=(long)newsize;
	};
	long* ps;long* pf;
	long* s;long* f;
	newpointer=(long)newpointer+(long)ppresprites[0];
	if(newpointer[0]!=NULL){//already opened this sprite
		ps=(long)newpointer[0];
		newpointer=(long)newpointer-(long)ppresprites[0];
		newpointer=(long)newpointer+(long)psprites[0];
		s=(long)newpointer[0];//is not done and moved, normally
		newsize=(long)((struct presprite*)ps)->size;
		if(type==from_show){
			newsize=(long)newsize+(long)sizeof(long);
			ok=(long)re_calloc_size(&((struct presprite*)ps)->preframes,&((struct presprite*)ps)->size,newsize);
			if(ok!=EXIT_SUCCESS){
				return EXIT_FAILURE;
			};
			ok=(long)re_calloc_size(&((struct sprite*)s)->frames,&((struct sprite*)s)->size,newsize);//set size at move time? still extra code to reset ps size if not ok at s
			if(ok!=EXIT_SUCCESS){
				return EXIT_FAILURE;
			};
		}else{//from action
			if(ainit==xlog_ainit_false){
				newsize=(long)newsize-(long)sizeof(long);//to point at last
				pf=(long)((struct presprite*)ps)->preframes;
				f=(long)((struct sprite*)s)->frames;
				pf=(long)pf+(long)newsize;
				f=(long)f+(long)newsize;
				if(pf[0]==NULL){//is after a show
					f[0]=(long)nframe_init(pf,linestotal);
					if(f[0]==NULL){
						return EXIT_FAILURE;
					};
					//set p_linestotal# 0
				}else{//is multiple action call
					ok=(long)frame_expand(f[0],linestotal);
					if(ok!=EXIT_SUCCESS){
						return EXIT_FAILURE;
					};
				};
			}else{//if ainit=(xlog_ainit_true) #ainit/button , here is multiple action call. not after oalt
				ok=(long)frame_expand(((struct sprite*)s)->aframe,linestotal);
				if(ok!=EXIT_SUCCESS){
					return EXIT_FAILURE;
				};
			};
		};
		return EXIT_SUCCESS;
	};
	ps=(long)malloc(sizeof(struct presprite));
	if(ps!=NULL){
		newpointer[0]=(long)ps;
		((struct presprite*)ps)->apreframe=(long)NULL;
		((struct presprite*)ps)->preframes=(long)malloc(sprites_realloc_onepart);
		pf=(long)((struct presprite*)ps)->preframes;
		if(pf!=NULL){
			pf[0]=(long)NULL;
			((struct presprite*)ps)->size=(long)sizeof(long);
			//and for sprites
			s=(long)malloc(sizeof(struct sprite));
			if(s!=NULL){
				newpointer=(long)newpointer-(long)ppresprites[0];
				newpointer=(long)newpointer+(long)psprites[0];
				newpointer[0]=(long)s;
				((struct sprite*)s)->aframe=(long)NULL;
				((struct sprite*)s)->frames=(long)malloc(sprites_realloc_onepart);
				f=(long)((struct sprite*)s)->frames;
				if(f!=NULL){
					f[0]=(long)NULL;
					((struct sprite*)s)->size=(long)sizeof(long);
					if(type==from_show){
						pf++;
						pf[0]=(long)NULL;
						((struct presprite*)ps)->size=(long)((struct presprite*)ps)->size+(long)sizeof(long);
						f++;
						f[0]=(long)NULL;
						((struct sprite*)s)->size=(long)((struct sprite*)s)->size+(long)sizeof(long);
					}else{//from_action
						if(ainit==xlog_ainit_false){//here is the case when first frame has action (a popular case)
							f[0]=(long)nframe_init(pf,linestotal);
							if(f[0]==NULL){
								return EXIT_FAILURE;
							};
						}else{//ainit true
							((struct sprite*)s)->aframe=(long)nframe_init(&((struct presprite*)ps)->apreframe,linestotal);
							if(((struct sprite*)s)->aframe==NULL){
								return EXIT_FAILURE;
							};
						};
						//set p_linestotal# 0
					};
					return EXIT_SUCCESS;
				};
			};
		};
	};
	return EXIT_FAILURE;
};
long*     presprite_done(long* sprites,unsigned short preid,unsigned short id,long* data,long* presprites){
	long* pointer=sizeof(long);
	pointer=(long)pointer*(long)preid;
	if((unsigned long)pointer<(unsigned long)presprites_size){//#can be a done with no action/show
		pointer=(long)pointer+(long)sprites;
		if(pointer[0]!=NULL){//same
			jumpforwards_done(presprites,preid);
			long* destination=sizeof(long);
			destination=(long)destination*(long)id;
			destination=(long)destination+(long)sizeof(long);//for size comparison
			if((unsigned long)destination>(unsigned long)((struct oadata*)data)->sprites_size){
				unsigned char ok;
				ok=(long)re_calloc_size(&((struct oadata*)data)->sprites,&((struct oadata*)data)->sprites_size,destination);
				if(ok!=EXIT_SUCCESS){
					return EXIT_FAILURE;
				};
			};
			destination=(long)destination-(long)sizeof(long);
			destination=(long)destination+(long)((struct oadata*)data)->sprites;
			destination[0]=(long)pointer[0];
			pointer[0]=(long)NULL;
		};
	};
	return EXIT_SUCCESS;
};

