long*re_alloc(unsigned long*,unsigned int);
long*re_calloc(unsigned long*,unsigned long*,unsigned long);
long*re_calloc_size(unsigned long*,unsigned int*,unsigned int);
long*re_alloc_add(unsigned long*,unsigned int*,unsigned long);
long*re_calloc_add(unsigned long*,unsigned int*);
long*preframe_init();
void frame_print_top(unsigned char,int);
void preframe_free(long*,unsigned char,int,unsigned long);
long*frame_init(unsigned long);
void frame_print_action(unsigned long,unsigned long,unsigned char,unsigned char);
void frame_print_action_flag(unsigned char,unsigned char,unsigned char);
void frame_print(unsigned long,unsigned int,unsigned long);
void frame_free(long*,unsigned char,int);
long*nframe_init(long*,unsigned long);
long*get_nframe(long*,long*,unsigned short,unsigned char,long*);
long*frame_text_add(unsigned long,unsigned long*,unsigned long);
long*frame_actions(unsigned long,unsigned long,unsigned char*,unsigned long,unsigned long*,unsigned long*);
long*frame_expand(unsigned long,unsigned long);
#include "common.h"
//
long*branch_init(long);
//
//
//
long*text_after_nlines(long,long,long);
long*memnlcr(long,long,long);
long*     re_alloc(unsigned long* pmem,unsigned int size){//only dataxu external sizes, and +1 increments
	if(size!=0){
		unsigned int currentmaxsize;currentmaxsize=(long)size;
		currentmaxsize=(unsigned long)currentmaxsize/(long)(sprites_realloc_onepart);
		currentmaxsize=(long)currentmaxsize*(long)(sprites_realloc_onepart);
		if(size==currentmaxsize){
			currentmaxsize=(long)currentmaxsize+(long)(sprites_realloc_onepart);
			long* newmem;newmem=(long)realloc(pmem[0],currentmaxsize);
			if(newmem!=NULL){
				pmem[0]=(long)newmem;
				return EXIT_SUCCESS;
			};
			return EXIT_FAILURE;
		};// else is not on the edge
		//else can be at presprite_init x2, string_add x2, presprite_done function
	};
	return EXIT_SUCCESS;
};
long*     re_calloc(unsigned long* pmem,unsigned long* size,unsigned long newsize){
	unsigned char ok;ok=(long)re_alloc(pmem,size);
	if(ok==EXIT_SUCCESS){
		size=(long)size+(long)pmem[0];
		newsize=(long)newsize+(long)pmem[0];
		while(size!=newsize){
			size[0]=(long)NULL;
			size=(long)size+(long)sizeof(long);
		};
	};
	return ok;
};
long*     re_calloc_size(unsigned long* pmem,unsigned int* psize,unsigned int newsize){
	unsigned char ok;ok=(long)re_calloc(pmem,psize[0],newsize);
	if(ok==EXIT_SUCCESS){
		psize[0]=(long)newsize;
	};
	return ok;
};
long*     re_alloc_add(unsigned long* pmem,unsigned int* psize,unsigned long value){
	unsigned char ok;ok=(long)re_alloc(pmem,psize[0]);
	if(ok==EXIT_SUCCESS){
		long* mem;mem=(long)pmem[0];
		mem=(long)mem+(long)psize[0];
		mem[0]=(long)value;
		psize[0]=(long)psize[0]+(long)sizeof(long);
	};
	return ok;
};
long*     re_calloc_add(unsigned long* pmem,unsigned int* psize){
	unsigned int newsize;
	newsize=(long)psize[0];
	newsize=(long)newsize+(long)sizeof(long);
	unsigned char ok;ok=(long)re_calloc_size(pmem,psize,newsize);
	return ok;
};
long*     preframe_init(){//0
	long* pf;pf=(long)malloc(sizeof(struct preframe));
	if(pf!=NULL){
		long* ustrings;
		ustrings=(long)malloc(sprites_realloc_onepart);
		if(ustrings!=NULL){
			long* strings;
			strings=(long)malloc(sprites_realloc_onepart);
			if(strings!=NULL){
				long* ifs;
				ifs=(long)malloc(sprites_realloc_onepart);
				if(ifs!=NULL){
					long* jumps;
					jumps=(long)malloc(sprites_realloc_onepart);
					if(jumps!=NULL){
						unsigned char blog;blog=(long)global_blog();
						if(blog==TRUE){
							((struct preframe*)pf)->log_recalculation=(long)0;
							tree_frame_init(pf);
							((struct preframe*)pf)->log_xsize=(long)0;
							((struct preframe*)pf)->log_branchid=(long)-1;//will inc to 0 at branch_init
							((struct preframe*)pf)->log_sizedfunctions=(long)0;
						};
						((struct preframe*)pf)->size=(long)0;//used at branch_init
						((struct preframe*)pf)->abranch=(long)branch_init(pf);//no ,topbranch,suprabranch since this is on root level and } can't happen and there is nothing for suprabranch
						if(((struct preframe*)pf)->abranch!=NULL){
							((struct preframe*)pf)->ustrings=(long)ustrings;
							((struct preframe*)pf)->ussize=(long)0;
							((struct preframe*)pf)->strings=(long)strings;
							((struct preframe*)pf)->ssize=(long)0;
							((struct preframe*)pf)->action_last=(long)NULL;
							((struct preframe*)pf)->actions_if=(long)ifs;
							((struct preframe*)pf)->actions_if_size=(long)0;
							((struct preframe*)pf)->actions_jump=(long)jumps;
							((struct preframe*)pf)->actions_jump_size=(long)0;
							return pf;
						};
						free(jumps);
					};
					free(ifs);
				};
				free(strings);
			};
			free(ustrings);
		};
		free(pf);
	};
	return NULL;
};
void      frame_print_top(unsigned char ainit,int log_index){
	if(ainit==xlog_ainit_false){
		print("frame %u",log_index);
	}else{
		prints("init");
	};
	print_indent();
};
void      preframe_free(long* pf,unsigned char ainit,int log_index,unsigned long logstart){
	unsigned char log;
	//valuexu stroff#1
	if(log_index!=no_index){
		frame_print_top(ainit,log_index);
		if(((struct preframe*)pf)->log_sizedfunctions!=0){
			print("sizedfunctions: %u",((struct preframe*)pf)->log_sizedfunctions);
		};
		prints_inline_start("ustrings:");
		log=(long)TRUE;
	}else{
		log=(long)FALSE;
	};
	unsigned long str;
	//is a different free than strings, will have one branch vs multiple
	long* ustrings;ustrings=(long)((struct preframe*)pf)->ustrings;
	long* s;s=(long)ustrings;
	long* end;end=(long)((struct preframe*)pf)->ussize;
	end=(long)end+(long)s;
	while(s!=end){
		str=(long)s[0];
		if(log==TRUE){
			string_log(((struct ustring*)str)->base,((struct ustring*)str)->off);
			unsigned long bra;bra=(long)((struct ustring*)str)->ubranch;
			putchar(Comma);
			printf("%u",((struct branch*)bra)->log_id);
		};
		free(str);
		s++;
	};
	free(ustrings);
	if(log==TRUE){
		print_inline_done();
		prints_inline_start("strings:");
	};
	long* strings;strings=(long)((struct preframe*)pf)->strings;
	s=(long)strings;
	end=(long)((struct preframe*)pf)->ssize;
	end=(long)end+(long)s;
	while(s!=end){
		str=(long)s[0];
		if(log==TRUE){
			string_log(((struct string*)str)->base,((struct string*)str)->off);
			long* brs;brs=(long)((struct string*)str)->branches;
			unsigned long brsend;brsend=(long)brs;
			brsend=(long)brsend+(long)((struct string*)str)->size;
			while(brs!=brsend){
				unsigned long br;br=(long)brs[0];
				putchar(Comma);
				printf("%u",((struct branch*)br)->log_id);
				brs=(long)brs+(long)sizeof(long);
			};
		};
		free(((struct string*)str)->branches);
		free(str);
		s++;
	};
	free(strings);
	if(log==TRUE){
		print_inline_done();
		unsigned int finalsize;finalsize=(long)((struct preframe*)pf)->size;
		finalsize=(long)finalsize+(long)((struct preframe*)pf)->log_recalculation;
		indent();
		print_hex_start("asize",((struct preframe*)pf)->size);//              is without pool and end tag
		print_hex("fasize",finalsize);//final action size. is without pool and end tag
		print_lhex("size",((struct preframe*)pf)->log_xsize);
		print_inline_done();
		branch_free(((struct preframe*)pf)->abranch,logstart,0);
		tree_frame_free(pf);
		print_unindent();
	}else{
		branch_free(((struct preframe*)pf)->abranch,NULL);
	};
	free(((struct preframe*)pf)->actions_if);
	free(((struct preframe*)pf)->actions_jump);
	free(pf);
};
#define frame_text_allocpart pad_default
long*     frame_init(unsigned long total){
	long* f;f=(long)malloc(sizeof(struct frame));
	if(f!=NULL){
		long* text;text=(long)malloc(frame_text_allocpart);
		if(text!=NULL){
			long* lines;
			//charx bool#1;set bool (TRUE)
			//if total!=0 even "" is 1 line
			unsigned long size;size=(long)sizeof(struct line);
			size=(long)size*(long)total;
			lines=(long)malloc(size);
			if(lines!=NULL){
				((struct frame*)f)->lines=(long)lines;
				((struct frame*)f)->total=(long)0;
				((struct frame*)f)->text=(long)text;
				((struct frame*)f)->size=(long)0;
				return f;
			};
			free(text);
		};
		free(f);
	};
	return NULL;
};
void      frame_print_action(unsigned long a,unsigned long b,unsigned char c,unsigned char d){
	if(a!=b){
		if(d==FALSE){
			putchar(c);
		};
	}else if(d==TRUE){
		putchar(c);
	};
};
void      frame_print_action_flag(unsigned char flags,unsigned char f,unsigned char c){
	flags=(long)flags&(long)f;
	if(flags==f){
		putchar(c);
	};
};
void      frame_print(unsigned long n,unsigned int nr_actions,unsigned long actions){
	putchar(Space);
	printf("%u,%u",n,nr_actions);
	unsigned long end;
	end=(long)sizeof(struct action);
	end=(long)end*(long)nr_actions;
	end=(long)end+(long)actions;
	while(actions!=end){
		// m can't be with i/f, m can be at end?
		//these functions to have this function small? yes, and will be hard coded if not this way
		//call (int,imm32) #this goes full 64 bits on both o/c, there ulong,ulong
		// El at loop end,if this there, still need to ask if actions!=NULL	#this is also good at cut ends and end jumps
		frame_print_action(((struct action*)actions)->amark,action_mark_default,Ml,FALSE);
		frame_print_action(((struct action*)actions)->nextif,action_nextif_default,Il,FALSE);
		frame_print_action(((struct action*)actions)->next,action_next_default,El,TRUE);
		unsigned char f;f=(long)((struct action*)actions)->flags;
		frame_print_action_flag(f,if_flag,Fl);
		frame_print_action_flag(f,call_flag,Cl);
		frame_print_action_flag(f,return_flag,Rl);
		actions=(long)actions+(long)sizeof(struct action);
	};
};
void      frame_free(long* f,unsigned char ainit,int log_index){
	unsigned long n;unsigned int nr_actions;
	unsigned long t;t=(long)((struct frame*)f)->total;
	long* lines;lines=(long)((struct frame*)f)->lines;// why to have blank lines anyway
	if(log_index!=no_index){
		frame_print_top(ainit,log_index);
		print_inline_start("lines=%lu",t);
		if(t!=0){
			n=(long)0;
			nr_actions=(long)((struct line*)lines)->total;
		};
	};
	if(t!=0){// action("") is 1 line
		unsigned long ix;unsigned long actions;
		ix=(long)0;
		actions=(long)((struct line*)lines)->actions;
		unsigned long end;end=(long)sizeof(struct line);
		end=(long)end*(long)t;
		long* pointer;pointer=(long)lines;
		end=(long)end+(long)pointer;
		while(pointer!=end){
			unsigned long i;i=(long)((struct line*)pointer)->index;
			if(i!=ix){
				if(log_index!=no_index){
					frame_print(n,nr_actions,actions);
					n=(long)1;
					nr_actions=(long)((struct line*)pointer)->total;
				};
				if(actions!=NULL){
					free(actions);
				};
				ix=(long)i;
				actions=(long)((struct line*)pointer)->actions;
			}else if(log_index!=no_index){
				n++;
			};
			pointer=(long)pointer+(long)sizeof(struct line);
		};
		if(log_index!=no_index){
			frame_print(n,nr_actions,actions);
		};
		if(actions!=NULL){
			free(actions);
		};
		free(lines);
	};
	if(log_index!=no_index){
		print_inline_done();
		print("text: size=%lu <<<",((struct frame*)f)->size);
		print_indent();
		print_text(((struct frame*)f)->text,((struct frame*)f)->size);
		print_unindent();
		prints("<<<");
		print_unindent();
	};
	free(((struct frame*)f)->text);
	free(f);
};
long*     nframe_init(long* pf,unsigned long total){//2
	pf[0]=(long)preframe_init();
	if(pf[0]!=NULL){
		unsigned long f;f=(long)frame_init(total);
		return f;
	};
	return NULL;
};
long*     get_nframe(long* presprites,long* sprites,unsigned short preid,unsigned char ainit,long* ppf){//5
	long* ps=sizeof(long);
	ps=(long)ps*(long)preid;
	long* s;s=(long)ps;
	ps=(long)ps+(long)presprites;
	ps=(long)ps[0];
	s=(long)s+(long)sprites;
	s=(long)s[0];
	if(ainit==xlog_ainit_false){
		long* pf;
		pf=(long)((struct presprite*)ps)->preframes;
		pf=(long)pf+(long)((struct presprite*)ps)->size;
		pf--;
		ppf[0]=(long)pf[0];
		long* f;
		f=(long)((struct sprite*)s)->frames;
		f=(long)f+(long)((struct sprite*)s)->size;
		f--;
		return f[0];
	};
	ppf[0]=(long)((struct presprite*)ps)->apreframe;
	return ((struct sprite*)s)->aframe;
};
//with () for c
#define frame_text_allocpart_ (frame_text_allocpart-1)
#define _frame_text_allocpart_ ~frame_text_allocpart_
long*     frame_text_add(unsigned long fr,unsigned long* _text,unsigned long lines){
	unsigned long starttext;starttext=(long)_text[0];
	unsigned long number_of_crnl;number_of_crnl=(long)0;
	unsigned long endtext;endtext=(long)text_after_nlines(starttext,lines,&number_of_crnl);
	unsigned long size;size=(long)endtext;
	size=(long)size-(long)starttext;
	size=(long)size-(long)number_of_crnl;
	unsigned long test;test=(long)_frame_text_allocpart_;
	test=(long)test&(long)((struct frame*)fr)->size;
	unsigned long test3;test3=(long)((struct frame*)fr)->size;
	test3=(long)test3+(long)size;
	unsigned long test2;test2=(long)_frame_text_allocpart_;
	test2=(long)test2&(long)test3;
	unsigned char* mem;
	if(test!=test2){
		test2=(long)test2+(long)frame_text_allocpart;
		//only drawback: if on edge will still go one more part
		mem=(long)realloc(((struct frame*)fr)->text,test2);
		if(mem==NULL){
			return EXIT_FAILURE;
		};
		((struct frame*)fr)->text=(long)mem;
	}else{
		mem=(long)((struct frame*)fr)->text;
	};
	//out text will be with nl
	mem=(long)mem+(long)((struct frame*)fr)->size;
	unsigned char* next;unsigned long p;
	while(starttext!=endtext){
		p=(long)memnlcr(starttext,&next,NULL);
		p=(long)p-(long)starttext;
		memcpy(mem,starttext,p);
		mem=(long)mem+(long)p;
		mem[0]=(long)output_nl;
		mem++;
		starttext=(long)next;
	};
	_text[0]=(long)endtext;
	((struct frame*)fr)->size=(long)((struct frame*)fr)->size+(long)size;
	return EXIT_SUCCESS;
};
long*     frame_actions(unsigned long fr,unsigned long lines,unsigned char* log,unsigned long end,unsigned long* _text,unsigned long* _actions){
	unsigned char ok;ok=(long)frame_text_add(fr,_text,lines);
	if(ok==EXIT_SUCCESS){
		unsigned long current;current=(long)((struct frame*)fr)->total;
		unsigned long p_lines=sizeof(struct line);
		p_lines=(long)p_lines*(long)current;
		unsigned long lines_start;lines_start=(long)((struct frame*)fr)->lines;
		p_lines=(long)p_lines+(long)lines_start;//space for lines was reserved at start knowing log total lines
		//here there is at least a row with actions, so frame.lines is not NULL
		//test how many actions to alloc
		unsigned int nr_of_actions;nr_of_actions=(long)0;
		while(log!=end){
			if(log[0]==xlog_act){
				nr_of_actions++;
			};
			log++;
		};
		((struct line*)p_lines)->index=(long)current;//there is no 0 lines per row
		((struct line*)p_lines)->total=(long)nr_of_actions;
		((struct frame*)fr)->total=(long)((struct frame*)fr)->total+(long)lines;
		lines=(long)lines*(long)sizeof(struct line);
		lines=(long)lines+(long)p_lines;
		unsigned long pointer;
		pointer=(long)sizeof(struct line);
		pointer=(long)pointer+(long)p_lines;
		while(pointer!=lines){//#link empty lines
			((struct line*)pointer)->index=(long)current;
			((struct line*)pointer)->actions=(long)NULL;
			pointer=(long)pointer+(long)sizeof(struct line);
		};
		if(nr_of_actions!=0){//can be 0, at ./example are many cases
			unsigned long cursor;
			cursor=(long)sizeof(struct action);
			cursor=(long)cursor*(long)nr_of_actions;
			((struct line*)p_lines)->actions=(long)malloc(cursor);
			if(((struct line*)p_lines)->actions!=NULL){
				//default action values
				pointer=(long)((struct line*)p_lines)->actions;
				cursor=(long)cursor+(long)pointer;
				while(pointer!=cursor){
					cursor=(long)cursor-(long)sizeof(struct action);
					((struct action*)cursor)->next=(long)action_next_default;//last one is null
					((struct action*)cursor)->nextif=(long)action_nextif_default;//other way at ActionIf
					((struct action*)cursor)->flags=(long)no_flags;
					((struct action*)cursor)->amark=(long)action_mark_default;//other way at branch start
				};
				_actions[0]=(long)pointer;
				//now with preframe.action_last
				//link first from here with prev
				//if current!=0 #if is not first action in frame
				//while lines_start!=p_lines
				//	sub p_lines \line\  #if prev are tricks, will never find a prev
				//	if p_lines#:line.actions!=(NULL)
				//		valueu acts#1;set acts \action\
				//		mult acts p_lines#:line.total ##total is uint
				//		sub acts \action\
				//		add acts p_lines#:line.actions
				//		set acts#:action.next pointer
				//		break
				//	end
				//end
				return EXIT_SUCCESS;
			};
		}else{//prev rows can also be tricks: while(true) break many times
			((struct line*)p_lines)->actions=(long)NULL;
			return EXIT_SUCCESS;
		};
	};
	return EXIT_FAILURE;
};
long*     frame_expand(unsigned long fr,unsigned long lines){//,sv p_totallines)
	lines=(long)lines+(long)((struct frame*)fr)->total;
	//if lines!=0  action("") is 1 line
	unsigned long alloc;alloc=(long)sizeof(struct line);
	alloc=(long)alloc*(long)lines;
	unsigned long re;
	re=(long)realloc(((struct frame*)fr)->lines,alloc);
	if(re!=NULL){
		((struct frame*)fr)->lines=(long)re;
		//set p_totallines# fr#:frame.total
		//this is at end because can be truncated on last blank lines: set fr#:frame.total lines
		return EXIT_SUCCESS;
	};
	//end
	return EXIT_FAILURE;
};
