void oadata_free(long*,unsigned char);
long*oadata_make(unsigned char*,unsigned long*,unsigned char);
long*oadata_ok(unsigned char*);
long*oadata_logpad_get();
void oadata_logpad_set(unsigned char);
#include "common.h"
//multithread unsafe
unsigned char logpad=xlog_pad_default;
//
//functions(except oadata_free,oadata_logpad) are returning 0(long) on success and != on failure (EXIT_FAILURE or another != (from extern calls))
//
long*fcontent(long,long);
//
long*inter_extension(long);
long*inter_last_extension(long);
void      oadata_free(long* data,unsigned char log){//2
	if(data!=NULL){
		long* sprites;sprites=(long)((struct oadata*)data)->sprites;
		if(sprites!=NULL){
			long* s;s=(long)sprites;
			long* end;end=(long)((struct oadata*)data)->sprites_size;
			end=(long)end+(long)s;
			if(log==TRUE){
				puts("sprites:");
			};
			while(s!=end){
				if(log!=TRUE){
					sprite_free(s,NULL);
				}else{
					sprite_free(s,sprites);
				};
				s++;
			};
			free(sprites);
			long* functions;functions=(long)((struct oadata*)data)->functions;
			if(functions!=NULL){
				if(log==TRUE){
					s=(long)((struct oadata*)data)->functions_size;
					s=(long)s/(long)sizeof(long);
					print("functions: %u",s);
				};
				free(functions);
				long* marks;marks=(long)((struct oadata*)data)->marks;
				if(marks!=NULL){
					if(log==TRUE){
						unsigned long sz;sz=(long)((struct oadata*)data)->size;
						sz=(long)sz/(long)sizeof(struct mark);
						printf("marks: %u",sz);
						if((unsigned long)sz>(unsigned long)sizeof(struct mark)){
							//log first and last
							unsigned long tolog;tolog=(long)marks;
							tolog=(long)tolog+(long)((struct oadata*)data)->size;
							tolog=(long)tolog-(long)sizeof(struct mark);
							printf(": %d %u ... %u %d",((struct mark*)marks)->prev,((struct mark*)marks)->next,((struct mark*)tolog)->prev,((struct mark*)tolog)->next);
						};
						print_inline_done();
					};
					free(marks);
				};
			};
		};
		free(data);
	};
};
long*     oadata_make(unsigned char* swf_fullpath,unsigned long* poadata,unsigned char log){//3
	poadata[0]=(long)NULL;
	int* size;size=(long)strlen(swf_fullpath);
	unsigned char logext[]=".log";unsigned char* slogext=logext;
	int* allsize=sizeof(logext);allsize=(long)allsize+(long)size;
	int* mem;mem=(long)malloc(allsize);
	if(mem!=NULL){
		int* exit;
		memcpy(mem,swf_fullpath,size);
		size=(long)size+(long)mem;
		memcpy(size,slogext,sizeof(logext));
		int* logsize;
		int* logcontent;logcontent=(long)fcontent(mem,&logsize);
		if(logcontent!=NULL){
			unsigned char xext[]=".x";unsigned char* sxext=xext;
			memcpy(size,sxext,sizeof(xext));
			int* dummy;
			int* xcontent;xcontent=(long)fcontent(mem,&dummy);
			if(xcontent!=NULL){
				unsigned char xxext[]=".xx";unsigned char* sxxext=xxext;
				memcpy(size,sxxext,sizeof(xxext));
				int* xxcontent;xxcontent=(long)fcontent(mem,&dummy);
				if(xxcontent!=NULL){
					exit=(long)oadata_init(poadata);
					if(exit==EXIT_SUCCESS){
						long* presprites;
						long* sprites;//these will be filled before sprite done
						exit=(long)preoadata_init(&presprites,&sprites);
						if(exit==EXIT_SUCCESS){
							if(log==TRUE){
								tree_init();
							};
							exit=(long)loop(logcontent,xcontent,xxcontent,logsize,&presprites,&sprites,poadata[0],log);
							if(exit==EXIT_SUCCESS){
								if(log==TRUE){
									exit=(long)tree_exit();
								};
								if(exit==EXIT_SUCCESS){
									exit=(long)presprite_done(sprites,0,0,poadata[0],presprites);//root has not a done(0 to 0) in .log
									if(exit==EXIT_SUCCESS){
										exit=(long)inter(presprites,swf_fullpath,poadata[0]);
									};
								};
							};
						};
						if(exit==EXIT_SUCCESS){
							preoadata_free(presprites,sprites,log,xcontent);
						}else{
							preoadata_free(presprites,sprites,FALSE);
						};
					};
					if(exit!=EXIT_SUCCESS){
						oadata_free(poadata[0],FALSE);//there are multiple mallocs in outinit
					};
					free(xxcontent);
				}else{
					exit=(long)EXIT_FAILURE;
				};
				free(xcontent);
			}else{
				exit=(long)EXIT_FAILURE;
			};
			free(logcontent);
		}else{
			exit=(long)EXIT_FAILURE;
		};
		free(mem);
		return exit;
	};
	return EXIT_FAILURE;
};
long*     oadata_ok(unsigned char* swf_fullpath){
	// move ...last.data ...data
	int* size;size=(long)strlen(swf_fullpath);
	unsigned char* slastinter;int* size1;
	slastinter=(long)inter_last_extension(&size1);
	size1=(long)size1+(long)size;
	int* from;from=(long)malloc(size1);
	if(from!=NULL){
		unsigned char* sinterfinal;int* size2;
		sinterfinal=(long)inter_extension(&size2);
		size2=(long)size2+(long)size;
		int* to;to=(long)malloc(size2);
		if(to!=NULL){
			memcpy(from,swf_fullpath,size);
			memcpy(to,swf_fullpath,size);
			size1=(long)size1-(long)size;
			size=(long)size+(long)from;
			memcpy(size,slastinter,size1);
			size=(long)size-(long)from;
			size2=(long)size2-(long)size;
			size=(long)size+(long)to;
			memcpy(size,sinterfinal,size2);
			int r;//same 0/-1, here is int
			unlink(to);//same 0/-1, on windows will not rename if "File exists"
			r=(long)rename(from,to);
			free(from);
			free(to);
			return r;
		};
		free(from);
	};
	return EXIT_FAILURE;
};
long*     oadata_logpad_get(){
	return logpad;
};
void      oadata_logpad_set(unsigned char a){
	if(a!=0){
		logpad=(long)a;
	}else{
		logpad=(long)1;
	};
};

